commit 6b417daf0c4c486a754ee99ec07c85aa5d55c610
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Fri Nov 22 19:47:52 2024 +0100

    c-family: Yet another fix for _BitInt & __sync_* builtins [PR117641]
    
    Sorry, the last patch only partially fixed the __sync_* ICEs with
    _BitInt(128) on ia32.
    Even for !fetch we need to error out and return 0.  I was afraid of
    APIs like __atomic_exchange/__atomic_compare_exchange, those obviously
    need to be supported even on _BitInt(128) on ia32, but they actually never
    sync_resolve_size, they are handled by adding the size argument and using
    the library version much earlier.
    For fetch && !orig_format (i.e. __atomic_fetch_* etc.) we need to return -1
    so that we handle it with a manualy __atomic_load +
    __atomic_compare_exchange loop in the caller, all other cases should
    be rejected.
    
    2024-11-22  Jakub Jelinek  <jakub@redhat.com>
    
            PR c/117641
            * c-common.cc (sync_resolve_size): For size 16 with _BitInt
            on targets where TImode isn't supported, use goto incompatible if
            !fetch.
    
            * gcc.dg/bitint-117.c: New test.
    
    (cherry picked from commit 44984f7f7523f136085ba60fd107ba8309d4115b)

diff --git a/gcc/c-family/c-common.cc b/gcc/c-family/c-common.cc
index 661115bf1db..d5b28efd6db 100644
--- a/gcc/c-family/c-common.cc
+++ b/gcc/c-family/c-common.cc
@@ -7383,11 +7383,10 @@ sync_resolve_size (tree function, vec<tree, va_gc> *params, bool fetch,
 
   size = tree_to_uhwi (TYPE_SIZE_UNIT (type));
   if (size == 16
-      && fetch
       && TREE_CODE (type) == BITINT_TYPE
       && !targetm.scalar_mode_supported_p (TImode))
     {
-      if (!orig_format)
+      if (fetch && !orig_format)
 	return -1;
       goto incompatible;
     }
diff --git a/gcc/testsuite/gcc.dg/bitint-117.c b/gcc/testsuite/gcc.dg/bitint-117.c
new file mode 100644
index 00000000000..16a76165d1e
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/bitint-117.c
@@ -0,0 +1,13 @@
+/* PR c/117641 */
+/* { dg-do compile { target bitint575 } } */
+/* { dg-options "-std=c23" } */
+
+void
+foo (_BitInt(128) *b)
+{
+  __sync_add_and_fetch (b, 1);			/* { dg-error "incompatible" "" { target { ! int128 } } } */
+  __sync_val_compare_and_swap (b, 0, 1);	/* { dg-error "incompatible" "" { target { ! int128 } } } */
+  __sync_bool_compare_and_swap (b, 0, 1);	/* { dg-error "incompatible" "" { target { ! int128 } } } */
+  __sync_lock_test_and_set (b, 1);		/* { dg-error "incompatible" "" { target { ! int128 } } } */
+  __sync_lock_release (b);			/* { dg-error "incompatible" "" { target { ! int128 } } } */
+}

